<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>DQMH, un peu plus qu'un framework</title>

		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/wovalab.css">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>

		<!-- Markdown -->
		<script type="text/javascript" src="marked.js"></script>
		<script type="text/javascript" src="markdown.js"></script>
	</head>
	<body>
		<div class="reveal">
			<div class="slides">
				<section>
					<h1>DQMH</h1>
					<h3>Un peu plus qu'un framework ?</h3>
					<p>
						<small>par <a href="https://www.linkedin.com/in/jourdanolivier">Olivier Jourdan </a></small>
					</p>
				</section>
				<!-- <section>
					<h3>Quelques mots de présentation...</h3>
					<img data-src="content/Badges.png"></br>
					<ul>
					<li>Découverte de LabVIEW en 1999</li>
					<li>Fondateur de Wovalab</li>
					</ul>
				</section>
				<section>
					<img data-src="content/Wovalab_AlliancePartner_DQMHTrustedAdvisor.png"></br>
					<ul>
					<li>Mise en oeuvre d'architecture logiciel</li>
					<li>Mise en oeuvre de processes d'ingénierie logiciel</li>
					<li>Accompagnement d'équipe de développement</li>
					</ul>
				</section> -->
				<section data-markdown>
					<textarea data-template>
						## DQMH : Delacor Queue Mesage Handler
					</textarea>
				</section>
				<section>
					<h3>Framework vs architecture</h3>
					<h5>Architecture :</h5> Vue abstraite des différentes parties d'une application et de leurs interactions. C'est la conception<br>
					<h5>Framework :</h5> Composants logiciels permettant la mise en oeuvre de l'Architecture. C'est l'implémentation<br>
				</section>
				<section>
					<h3>Pourquoi adopter un framework ?</h3>
					<ul>
						<li>Standardisation</li>
						<li>Gain de temps</li>
						<li>Plus de temps à consacrer sur les problématiques métiers</li>
					</ul>
				</section>
				<section>
					<h3>Lequel choisir ?</h3>
					<ul>
					<li>Propriétaire ou public ?</li>
					<li>Objet ?</li>
					<li>Acteurs ?</li>
					<li>...</li>
					</ul>
				</section>
				<section>
					<h3>DQMH</h3>
					<ul>
					<li>Les choix techniques retenus</li>
					<li>Les aides à la productivité</li>
					<li>Le test, le test, le test !</li>
					</ul>
				</section>
				<section>
					<h3>Installation</h3>
					<ul>
					<li>Depuis VI Package Manager</li>
					<li>A partir de LabVIEW 2014</li>
					<li>Gratuit</li>
					<li>Utilisable dans toute application, même commerciale</li>
					<img class="stretch" data-src="content/DQMH-vipm.png">
					</ul>
				</section>
				<section data-markdown>
					<textarea data-template>
						## Le code LabVIEW
					</textarea>
				</section>
					<!-- Techniques -->
				<section>
					<h3>Module (le diagramme)</h3>
					<img class="stretch" data-src="content/DQMH-module_diagram.png">
				</section>
				<section>
					<h3>Module (dans le projet)</h3>
					<img class="stretch" data-src="content/DQMH-module_project.png">
				</section>
				<section>
					<h3>Module (utilisation)</h3>
					<img class="stretch" data-src="content/DQMH-module_usage.png">
				</section>
				<section>
					<h3>Module (communication)</h3>
					<ul>
					<li>Request :
						<ul>
						<li>Commande avec ou sans retour d'information</li>
						<li>De l'extérieur vers le module</li>
						</ul>
					</li>
					<li>Broadcast :
						<ul>
						<li>Diffusion de données</li>
						<li>Du module vers l'extérieur</li>
						</ul>
					</li>
					</ul>
				</section>
				<section>
					<h3>Module (type)</h3>
					<ul>
					<li>Singleton :
						<ul>
						<li>Une seule instance</li>
						</ul>
					</li>
					<li>Cloneable :
						<ul>
						<li>Autant d'instances que souhaité</li>
						</ul>
					</li>
					</ul>
				</section>
					<!-- Tools -->
				<section data-markdown>
					<textarea data-template>
						## Les outils
					</textarea>
				</section>
				<section data-markdown>
					<textarea data-template>
						### Ajouter un module
						![Add DQMH module](content/DQMH-addmodule.png)
					</textarea>
				</section>
				<section data-markdown>
					<textarea data-template>
						### Autres outils associés aux modules
						![Add module template](content/DQMH-createmoduletemplate.png)

						- Renommer un module
						- Créer ses templates de module

					</textarea>
				</section>
				<section data-markdown>
					<textarea data-template>
						### Ajouter une requête
						![Add DQMH event](content/DQMH-addevent_dialog.png)
					</textarea>
				</section>
				<section data-markdown>
					<textarea data-template>
						### Ajouter une requête
						![Add DQMH event result](content/DQMH-addevent_request.png)
					</textarea>
				</section>
				<section data-markdown>
					<textarea data-template>
						### Autres outils associés aux requêtes
						![Add DQMH event menu](content/DQMH-event_menu.png)

						- Renommer une requête pour que son nom corresponde à sa fonction réel
						- Supprimer un requête devenu inutile
						- Convertir une requête de "Request" à "Request and wait for reply"
					</textarea>
				</section>
				<section data-markdown>
					<textarea data-template>
						## Le test, le test, le test !
						### Une philosophie ancrée au coeur de DQMH
					</textarea>
				</section>
				<section data-markdown>
					<textarea data-template>
						### Tester un module

						- Chaque module à son testeur
						- Chaque ajout de requête met à jour le testeur
						- Le testeur vous aide à :
						  - mettre au point le modules
						  - débuguer l'application
					</textarea>
				</section>
				<section>
					<h3>Démo</h3>Test d'un module
				</section>
				<section>
					<video data-autoplay src="content/TesteurModuleDqmh.mp4"></video>
				</section>
				<section>
					<h3>Démo</h3>Test "In App"
				</section>
				<section>
					<video data-autoplay src="content/TesteurInApp.mp4"></video>
				</section>
				<section data-markdown>
					<textarea data-template>
						### Valider un module

						- Lors de la mise à jour du framework
						  - Détection du code obsolète
						  - Correction automatique
						- Régulièrement en cours de développement
						  - Détection de problématique de performance
						  - Détection de problématique de développement
					</textarea>
				</section>
				<section>
					<h3>Démo</h3>Validation d'un module après mise à jour du framework
				</section>
				<section>
					<video data-autoplay src="content/UpgradeValidationModule.mp4"></video>
				</section>
				<section>
					<h3>Démo</h3>Validation d'un module en cours de développement
				</section>
				<section>
					<video data-autoplay src="content/ModuleValidation.mp4"></video>
				</section>
				<section data-markdown>
					<textarea data-template>
						### Créer des tests unitaires
						![Create Unit test](content/DQMH-createUnitTest.png)
					</textarea>
				</section>
				<section data-markdown>
					<textarea data-template>
						### Modifier le vi de test
						![Create Unit test](content/DQMH-UnitTestVi.png)
					</textarea>
				</section>
				<section data-markdown>
					<textarea data-template>
						## Mon avis
					</textarea>
				</section>
				<section>
					<h3>Le DQMH, un framework orienté...</h3>
						<ul>
						<li>...vers un maximum d'accessibilité</li>
						<li>...vers un maximum d'efficacité</li>
						<li>...vers un maximum de qualité</li>
						</ul>
				</section>
				<section data-markdown>
					<textarea data-template>
						### Le programme DQMH Trusted Advisor

						6 entreprises à travers le monde, reconue par DELACOR, pour leur maitrise du framework à même d'apporter de l'aide dans la conception, le développement et l'évolution des projets utilisant le framework.
					</textarea>
				</section>
				<section data-markdown>
					<textarea data-template>
						### One more thing

						DQMH est compatible Real-Time et il s'intègre parfaitement avec TestStand !

					</textarea>
				</section>
				<section>
					<h3>Ressources</h3>
					<ul>
					<li><a href="https://delacor.com/products/dqmh/">DQMH</a> </li>
					<li><a href="https://delacor.com/tips-and-tricks-for-a-successful-dqmh-based-project/">Astuces DQMH</a></li>
					<li><a href="https://delacor.com/dqmh-trusted-advisors/">DQMH Trusted Advisor</a></li>
					<li>Projets open sources de <a href="http://code.hampel-soft.com/">hampel Software Engineering</a> basés sur DQMH</li>
						<ul>
							<li><a href="https://gitlab.com/hampel-soft/dqmh/hse-application-template">Modèle d'application</a></li>
							<li><a href="https://gitlab.com/hampel-soft/dqmh/generic-networking">Connectivité réseau entre modules DQMH</a></li>
						</ul>
					</ul>
				</section>
				<section><h3>Merci de votre attention</h3></section>
			</div>
		</div>

		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				// Add the current slide number to the URL hash so that reloading the
				// page/copying the URL will return you to the same slide
				hash: true,

				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/highlight/highlight.js', async: true }
				]
			});
		</script>
		<a href="https://www.wovalab.com">
			<img style="position: absolute; top: 3%; left: 10%; border: 0;" width="160" height="36" src="https://www.wovalab.com/wp-content/uploads/2018/12/Wovalab_logo_header.png" class="custom-logo" alt="wovalab" itemprop="logo" srcset="https://www.wovalab.com/wp-content/uploads/2018/12/Wovalab_logo_H_RVB_1200.png 2x">
		</a>
	</body>
</html>
